<id>
Secure cross-browser Glow and Shadow SP 1.3.1
</id>

<version>
1.0
</version>

<mod info>

- adds new secure Glow and Shadow functions
- Glow and Shadow now supported in Mozilla/Netscape, Opera...

Instructions:

Apply this mod

Upload (in ASCII mode):
Sources/Display.pl
Sources/YaBBC.pl

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>


<edit file>
Sources/Display.pl
</edit file>

<search for>
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
</search for>

<add before>
		$glowbg = $windowbg;
</add before>


<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
sub decode_direction {
	$_ = $_[0];
	$_ =~ s~left~270~ig;
	$_ =~ s~right~90~ig;
	$_ =~ s~top~0~ig;
	$_ =~ s~bottom~180~ig;
	$_ =~ s~topright~45~ig;
	$_ =~ s~bottomright~135~ig;
	$_ =~ s~bottomleft~225~ig;
	$_ =~ s~topleft~315~ig;
	return $_;
}
</search for>

<replace>
sub decode_direction {
	$shadowDir = $_[0];
	$shadowDir =~ s~topright~-5|5|-4|4|-3|3|-2|2|-1|1~ig;
	$shadowDir =~ s~bottomright~5|5|4|4|3|3|2|2|1|1~ig;
	$shadowDir =~ s~bottomleft~5|-5|4|-4|3|-3|2|-2|1|-1~ig;
	$shadowDir =~ s~topleft~-5|-5|-4|-4|-3|-3|-2|-2|-1|-1~ig;
	$shadowDir =~ s~left~0|-5|0|-4|0|-3|0|-2|0|-1~ig;
	$shadowDir =~ s~right~0|5|0|4|0|3|0|2|0|1~ig;
	$shadowDir =~ s~top~-5|0|-4|0|-3|0|-2|0|-1|0~ig;
	$shadowDir =~ s~bottom~5|0|4|0|3|0|2|0|1|0~ig;
	return $shadowDir;
}
</replace>

<search for>
sub DoUBBC {
</search for>

<add before>
sub gradient {
if(!$glowbg) { $hex1 = $color{'windowbg'}; }
else { $hex1 = $glowbg; }
$hex2 = $_[0];
$steps = $_[1];
if($steps < 2) { $steps=2 }
if($steps > 7) { $steps = 7 }
@fromcol=();
@tocol=();
@color=();
@color1=();
@diff=();
$glowColors = "";
$fromcol[0]=sprintf("%d", hex(substr($hex1,1,2)));
$fromcol[1]=sprintf("%d", hex(substr($hex1,3,2)));
$fromcol[2]=sprintf("%d", hex(substr($hex1,5,2)));
$tocol[0]=sprintf("%d", hex(substr($hex2,1,2)));
$tocol[1]=sprintf("%d", hex(substr($hex2,3,2)));
$tocol[2]=sprintf("%d", hex(substr($hex2,5,2)));
$difdiv = $steps - 1;
for($i=0;$i<3;$i++) {
	$diff[$i] = $fromcol[$i] - $tocol[$i];
	$diff[$i] = sprintf("%d", ($diff[$i] / $difdiv));
	$color[$i] = $fromcol[$i];
	$color1[$i] = 0;
}
for($i=0;$i<$steps;$i++) {
	$glowColors .= qq~#~;
	for($x=0;$x<3;$x++) {
		if($color[$x] > 255) { $color[$x] = 255; }
		if($color[$x] < 0) { $color[$x] = 0; }
		$color1[$x] = sprintf("%02X", $color[$x]);
		$glowColors .= "$color1[$x]";
		$color[$x] -= $diff[$x];
	}
	$glowColors .= qq~|~;
}
$glowColors = substr($glowColors, 0, -1);
return $glowColors;
}

sub convColor {
$gloColor = $_[0];
$gloDeep = $_[1];
$gloColors = "";
$gloColor =~ s~Black~\#000000~i;
$gloColor =~ s~Gray~\#808080~i;
$gloColor =~ s~Red~\#FF0000~i;
$gloColor =~ s~Yellow~\#FFFF00~i;
$gloColor =~ s~Pink~\#FFC0CB~i;
$gloColor =~ s~Green~\#008000~i;
$gloColor =~ s~Orange~\#FFA500~i;
$gloColor =~ s~Purple~\#800080~i;
$gloColor =~ s~Blue~\#0000FF~i;
$gloColor =~ s~Beige~\#F5F5DC~i;
$gloColor =~ s~Brown~\#A52A2A~i;
$gloColor =~ s~Teal~\#008080~i;
$gloColor =~ s~Navy~\#000080~i;
$gloColor =~ s~Maroon~\#800000~i;
$gloColor =~ s~LimeGreen~\#32CD32~i;
$gloColor =~ s~Aqua~\#00FFFF~i;
$gloColors = &gradient($gloColor, $gloDeep);
return $gloColors;
}

sub makeGlow {
$theText = $_[0];
$orgText = $_[0];
$gldeep = $_[3];
if($gldeep > 7) { $gldeep = 7 }
$gloColorstr = &convColor($_[1], $gldeep);
@glowColor = ();
@glowColor = split(/\|/, $gloColorstr);
$tmpWidth = ($gldeep*2) + $_[2];
$glowWidth = &validwidth($tmpWidth);
$gloMarg = $gldeep;
$theText =~ s~\[color=\S+?\](.+?)\[/color\]~$1~eisg;
$theText =~ s~\[bgcolor=\S+?\](.+?)\[/bgcolor\]~$1~eisg;
$theText =~ s~\[black\](.+?)\[/black\]~$1~eisg;
$theText =~ s~\[white\](.+?)\[/white\]~$1~eisg;
$theText =~ s~\[red\](.+?)\[/red\]~$1~eisg;
$theText =~ s~\[green\](.+?)\[/green\]~$1~eisg;
$theText =~ s~\[blue\](.+?)\[/blue\]~$1~eisg;
$glowText = "";
$Deep = $gldeep;
$tDeep = $Deep;
$px = "px";
$glowText = qq~<div style="position: relative; left: $gldeep$px; width: $glowWidth$px; margin-top: $gloMarg$px; margin-bottom: $gloMarg$px;">~;
for($i=0;$i<$tDeep;$i++) {
	$gleft = 0 - $Deep; $gright = $Deep;  $gtop = 0; $gbottom = 0;
	for($z=0;$z<$Deep;$z++) {
		$gtop--; $gbottom++;
		$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gright$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
		$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gleft$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
		$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gright$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
		$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gleft$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
		$gleft++; $gright--;
	}
	$Deep--;
}
$i--;
$gtop++; $gbottom--;
$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gright$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gleft$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gright$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;
$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gleft$px; float: left; width: $glowWidth$px; color: $glowColor[$i];">$theText</span>~;

$glowText .= qq~<span style="position: absolute; top: 0px; left: 0px; float: left; width: $glowWidth$px;">$orgText</span>~;
$glowText .= qq~$theText</div>~;
return $glowText;
}

sub makeShadow {
$theText = $_[0];
$orgText = $_[0];
$shadColorstr = &convColor($_[1], 5);
@shadowColor = ();
@shadowColor = split(/\|/, $shadColorstr);
$tmpWidth = $_[2] + 5;
$shadowWidth = &validwidth($tmpWidth);
&decode_direction($_[3]);
($shadowDir1, $shadowDir2, $shadowDir3, $shadowDir4, $shadowDir5, $shadowDir6, $shadowDir7, $shadowDir8, $shadowDir9, $shadowDir10) = split(/\|/, $shadowDir);
$theText =~ s~\[color=\S+?\](.+?)\[/color\]~$1~eisg;
$theText =~ s~\[black\](.+?)\[/black\]~$1~eisg;
$theText =~ s~\[white\](.+?)\[/white\]~$1~eisg;
$theText =~ s~\[red\](.+?)\[/red\]~$1~eisg;
$theText =~ s~\[green\](.+?)\[/green\]~$1~eisg;
$theText =~ s~\[blue\](.+?)\[/blue\]~$1~eisg;
$shadowEnh = "px";
$shadowText = "";
$shadowText = qq~<div style="position: relative; left: 5px; width: $shadowWidth$px; margin-top: 5px; margin-bottom: 5px;">~;
$shadowText .= qq~<span style="position: absolute; top: $shadowDir1$shadowEnh; left: $shadowDir2$shadowEnh; float: left; width: $shadowWidth; color: $shadowColor[0];">$theText</span>~;
$shadowText .= qq~<span style="position: absolute; top: $shadowDir3$shadowEnh; left: $shadowDir4$shadowEnh; float: left; width: $shadowWidth; color: $shadowColor[1];">$theText</span>~;
$shadowText .= qq~<span style="position: absolute; top: $shadowDir5$shadowEnh; left: $shadowDir6$shadowEnh; float: left; width: $shadowWidth; color: $shadowColor[2];">$theText</span>~;
$shadowText .= qq~<span style="position: absolute; top: $shadowDir7$shadowEnh; left: $shadowDir8$shadowEnh; float: left; width: $shadowWidth; color: $shadowColor[3];">$theText</span>~;
$shadowText .= qq~<span style="position: absolute; top: $shadowDir9$shadowEnh; left: $shadowDir10$shadowEnh; float: left; width: $shadowWidth; color: $shadowColor[4];">$theText</span>~;
$shadowText .= qq~<span style="position: absolute; top: 0px; left: 0px; float: left; width: $shadowWidth;">$orgText</span>~;
$shadowText .= qq~$theText</div>~;
return $shadowText;
}

</add before>

<search for>
	$message =~ s~\[shadow=(\S+?),(\D\S+?),(\d+)\](.+?)\[/shadow\]~qq^\[shadow=$1,^ . &decode_direction($2) . qq^,$3\]$4\[/shadow\]^~eisg;
	$message =~ s~\[shadow=(\S+?),(\d+),(\d+)\](.+?)\[/shadow\]~qq^[&table width="^ . validwidth($3) . qq^" style="filter:shadow\(color=$1, direction=$2\)"\]$4\[/\&table\]^~eisg;
	$message =~ s~\[glow=(\S+?),(\d+),(\d+)\](.+?)\[/glow\]~qq^[&table width="^ . validwidth($3) . qq^" style="filter:glow\(color=$1, strength=$2\)"\]$4\[/\&table\]^~eisg;
</search for>

<replace>
	$message =~ s~\[shadow=(\w+?),(\D\S+?),(\d+)\](.+?)\[/shadow\]~&makeShadow($4,$1,$3,$2)~eisg;
	$message =~ s~\[glow=(\w+?),(\d+),(\d+)\](.+?)\[/glow\]~&makeGlow($4,$1,$3,$2)~eisg;
</replace>
